var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { r as registerInstance, c as createEvent, h, H as Host, g as getElement } from './index-6c2aa636.js';
function lazyLoadComponentContent(el, tag) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        var promises, elements;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    promises = [];
                    elements = getAllElements(el, tag);
                    if (!(elements && elements.length > 0)) return [3 /*break*/, 2];
                    elements.forEach(function (element) {
                        promises.push(element.lazyLoadContent());
                    });
                    return [4 /*yield*/, Promise.all(promises)];
                case 1:
                    _a.sent();
                    resolve();
                    _a.label = 2;
                case 2:
                    resolve();
                    return [2 /*return*/];
            }
        });
    }); });
}
function getAllElements(el, tag) {
    var allSlottedElements = el.querySelectorAll(tag);
    var allShadowsElements = el.shadowRoot ? el.shadowRoot.querySelectorAll(tag) : [];
    return Array.from(allSlottedElements).concat(Array.from(allShadowsElements));
}
function lazyLoadSelectedImages(images) {
    return new Promise(function (resolve) {
        if (!images) {
            resolve();
            return;
        }
        images.forEach(function (image) {
            if (image.hasAttribute('data-src')) {
                image.setAttribute('src', "" + image.getAttribute('data-src'));
                image.removeAttribute('data-src');
                if (!image.classList.contains('deckgo-reveal')) {
                    image.style.setProperty('visibility', 'inherit');
                }
            }
            image.style.setProperty('pointer-events', 'none');
        });
        resolve();
    });
}
function lazyLoadSelectedLazyImagesComponent(components) {
    var _this = this;
    return new Promise(function (resolve) {
        if (!components) {
            resolve();
            return;
        }
        components.forEach(function (component) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, component.lazyLoad()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
        resolve();
    });
}
function lazyLoadImages(el) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        var promises;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    promises = [];
                    promises.push(lazyLoadLazyImgTags(el));
                    promises.push(lazyLoadLazyImgComponents(el));
                    return [4 /*yield*/, Promise.all(promises)];
                case 1:
                    _a.sent();
                    resolve();
                    return [2 /*return*/];
            }
        });
    }); });
}
function lazyLoadLazyImgTags(el) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        var images;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    images = getAllImages(el, 'img');
                    return [4 /*yield*/, lazyLoadSelectedImages(images)];
                case 1:
                    _a.sent();
                    resolve();
                    return [2 /*return*/];
            }
        });
    }); });
}
function lazyLoadLazyImgComponents(el) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        var images;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    images = getAllImages(el, 'deckgo-lazy-img');
                    return [4 /*yield*/, lazyLoadSelectedLazyImagesComponent(images)];
                case 1:
                    _a.sent();
                    resolve();
                    return [2 /*return*/];
            }
        });
    }); });
}
function hideLazyLoadImages(el) {
    return new Promise(function (resolve) {
        var images = getAllImages(el, 'img');
        if (!images) {
            resolve();
        }
        else {
            images = images.filter(function (image) { return image.getAttribute('data-src'); });
            images.forEach(function (image) {
                image.style.setProperty('visibility', 'hidden');
            });
            resolve();
        }
    });
}
function getAllImages(el, tag) {
    var allSlotedImages = el.querySelectorAll('[slot] ' + tag);
    var allShadowImages = el.shadowRoot ? el.shadowRoot.querySelectorAll(tag) : [];
    return Array.from(allSlotedImages).concat(Array.from(allShadowImages));
}
function showAllRevealElements(el) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        var elements, promises, _i, _a, element;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    elements = el.querySelectorAll('deckgo-reveal, deckgo-reveal-list');
                    if (!(elements && elements.length > 0)) return [3 /*break*/, 2];
                    promises = [];
                    for (_i = 0, _a = Array.from(elements); _i < _a.length; _i++) {
                        element = _a[_i];
                        promises.push(element.revealAll());
                    }
                    return [4 /*yield*/, Promise.all(promises)];
                case 1:
                    _b.sent();
                    _b.label = 2;
                case 2:
                    resolve();
                    return [2 /*return*/];
            }
        });
    }); });
}
function hideAllRevealElements(el) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        var elements, promises, _i, _a, element;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    elements = el.querySelectorAll('deckgo-reveal, deckgo-reveal-list');
                    if (!(elements && elements.length > 0)) return [3 /*break*/, 2];
                    promises = [];
                    for (_i = 0, _a = Array.from(elements); _i < _a.length; _i++) {
                        element = _a[_i];
                        promises.push(element.hideAll());
                    }
                    return [4 /*yield*/, Promise.all(promises)];
                case 1:
                    _b.sent();
                    _b.label = 2;
                case 2:
                    resolve();
                    return [2 /*return*/];
            }
        });
    }); });
}
function afterSwipe() {
    return new Promise(function (resolve) {
        resolve();
    });
}
function lazyLoadContent(el) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        var promises;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    promises = [];
                    promises.push(lazyLoadImages(el));
                    promises.push(lazyLoadComponentContent(el, 'deckgo-gif'));
                    promises.push(lazyLoadComponentContent(el, 'deckgo-youtube'));
                    return [4 /*yield*/, Promise.all(promises)];
                case 1:
                    _a.sent();
                    resolve();
                    return [2 /*return*/];
            }
        });
    }); });
}
var deckdeckgoSlideBigImgCss = ":host{position:relative;background:var(--background);color:var(--color);height:100%;z-index:var(--zIndex, 1);--slide-padding-top-default:64px;--slide-padding-end-default:64px;--slide-padding-bottom-default:64px;--slide-padding-start-default:64px}@media screen and (max-width: 1024px){:host{--slide-padding-top-default:16px;--slide-padding-end-default:32px;--slide-padding-bottom-default:16px;--slide-padding-start-default:32px}}div.deckgo-slide{display:-ms-flexbox;display:flex;padding:var(--slide-padding-top, var(--slide-padding-top-default)) var(--slide-padding-end, var(--slide-padding-end-default)) var(--slide-padding-bottom, var(--slide-padding-bottom-default)) var(--slide-padding-start, var(--slide-padding-start-default));width:calc(var(--slide-width) - var(--slide-padding-start, var(--slide-padding-start-default)) - var(--slide-padding-end, var(--slide-padding-end-default)));height:calc(var(--slide-height) - var(--slide-padding-top, var(--slide-padding-top-default)) - var(--slide-padding-bottom, var(--slide-padding-bottom-default)));-webkit-touch-callout:var(--slide-user-select, none);-webkit-user-select:var(--slide-user-select, none);-moz-user-select:var(--slide-user-select, none);-ms-user-select:var(--slide-user-select, none);user-select:var(--slide-user-select, none);user-drag:none;-webkit-user-drag:none}::slotted(ul),::slotted(ol){-webkit-padding-start:var(--slide-padding-start, var(--slide-padding-start-default));padding-inline-start:var(--slide-padding-start, var(--slide-padding-start-default))}::slotted([slot=notes]){display:none}::slotted([slot=actions]){position:absolute;top:var(--slide-actions-top, 32px);right:var(--slide-actions-end, 32px);left:var(--slide-actions-start);display:var(--slide-actions-display)}::slotted([slot=background]){position:var(--slide-background-position, absolute);top:var(--slide-background-top, 0);right:var(--slide-background-end);left:var(--slide-background-start, 0);pointer-events:none;z-index:-1;width:var(--slide-background-width);height:var(--slide-background-height)}@media print{div.deckgo-slide{padding:0;page-break-after:always;height:100vh}::slotted([slot=actions]){display:none}::slotted([slot=background]){display:var(--slide-background-print-display, none)}}div.deckgo-slide{-ms-flex-direction:column;flex-direction:column;-ms-flex-pack:center;justify-content:center;-ms-flex-align:center;align-items:center;margin:0 0}div.deckgo-slide .deckgo-big-img-container{overflow:hidden;text-align:center}div.deckgo-slide .deckgo-big-img-container img{max-width:var(--slide-img-max-width)}div.deckgo-slide .deckgo-big-img-container img:not(.cropped){max-width:100%;max-height:100%}::slotted([slot=title]){display:none}";
var capitalize = function (str) { return str.charAt(0).toUpperCase() + str.slice(1); };
var DeckdeckgoSlideBigImg = /** @class */ (function () {
    function class_1(hostRef) {
        registerInstance(this, hostRef);
        this.customActions = false;
        this.customBackground = false;
        this.imgSrc = '';
        this.imgDivisions = '';
        this.axis = 'x';
        this.reverse = false;
        this.currentStep = -1;
        this.slideDidLoad = createEvent(this, "slideDidLoad", 7);
    }
    Object.defineProperty(class_1.prototype, "divisions", {
        get: function () {
            return this.imgDivisions.split(';').map(function (str) {
                var num = parseInt(str);
                if (isNaN(num)) {
                    return 0;
                }
                return num;
            });
        },
        enumerable: true,
        configurable: true
    });
    class_1.prototype.componentDidLoad = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, hideLazyLoadImages(this.el)];
                    case 1:
                        _a.sent();
                        this.crop = this.el.shadowRoot.querySelector('.deckgo-big-img-container');
                        this.bigImg = this.el.shadowRoot.querySelector('img');
                        this.slideDidLoad.emit();
                        return [2 /*return*/];
                }
            });
        });
    };
    class_1.prototype.next = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this.prevNext(true);
            resolve();
        });
    };
    class_1.prototype.prev = function () {
        var _this = this;
        return new Promise(function (resolve) {
            _this.prevNext(false);
            resolve();
        });
    };
    class_1.prototype.prevNext = function (next) {
        var _this = this;
        var axisDimension = this.axis === 'x' ? 'width' : 'height';
        var perpendicularAxisDimension = this.axis === 'y' ? 'width' : 'height';
        var axisMarginStart = "margin" + (this.axis === 'x' ? 'Left' : 'Top');
        if (this.currentStep === -1 && next) {
            this.currentStep = this.reverse ? this.divisions.length : 0;
        }
        else if (this.currentStep === this.divisions.length && !next && this.reverse) {
            this.currentStep = -1;
        }
        else {
            this.currentStep = this.currentStep + (this.reverse ? -1 : 1) * (next ? 1 : -1);
        }
        if (this.currentStep === -1) {
            this.bigImg.classList.remove('cropped');
            this.bigImg.style[axisMarginStart] = '';
            this.bigImg.style[perpendicularAxisDimension] = '';
            this.crop.style[axisDimension] = '';
            this.crop.style[perpendicularAxisDimension] = '';
        }
        else {
            this.crop.style[perpendicularAxisDimension] = '100%';
            this.bigImg.style[perpendicularAxisDimension] = '100%';
            this.bigImg.classList.add('cropped');
            var previousNaturalDivision_1 = this.currentStep === 0 ? 0 : this.divisions[this.currentStep - 1];
            var calcCrop = function () {
                var imgClientLength = _this.bigImg["client" + capitalize(axisDimension)];
                var imgNaturalLength = _this.bigImg["natural" + capitalize(axisDimension)];
                var lengthFactor = imgClientLength / imgNaturalLength;
                var currentNaturalDivision = _this.currentStep === _this.divisions.length ? imgNaturalLength : _this.divisions[_this.currentStep];
                return {
                    length: (currentNaturalDivision - previousNaturalDivision_1) * lengthFactor,
                    shift: -(previousNaturalDivision_1 * lengthFactor)
                };
            };
            var crop = calcCrop();
            if (crop.length > this.el.shadowRoot.querySelector('.deckgo-big-img-container').clientHeight) {
                this.crop.style[perpendicularAxisDimension] = '';
                crop = calcCrop();
            }
            this.crop.style[axisDimension] = crop.length + 'px';
            this.bigImg.style[axisMarginStart] = crop.shift + 'px';
        }
    };
    class_1.prototype.isEnd = function () {
        return this.reverse ? this.currentStep === 0 : this.currentStep === this.divisions.length;
    };
    class_1.prototype.isBeginning = function () {
        return this.currentStep === -1;
    };
    class_1.prototype.beforeSwipe = function (enter) {
        var _this = this;
        return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
            var couldSwipe;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        couldSwipe = !this.divisions[0] || (enter ? this.isEnd() : this.isBeginning());
                        if (couldSwipe) {
                            resolve(true);
                            return [2 /*return*/];
                        }
                        if (!enter) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.next()];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 2: return [4 /*yield*/, this.prev()];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4:
                        resolve(false);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    class_1.prototype.afterSwipe = function () {
        return afterSwipe();
    };
    class_1.prototype.lazyLoadContent = function () {
        return lazyLoadContent(this.el);
    };
    class_1.prototype.revealContent = function () {
        return showAllRevealElements(this.el);
    };
    class_1.prototype.hideContent = function () {
        return hideAllRevealElements(this.el);
    };
    class_1.prototype.render = function () {
        return (h(Host, { class: { 'deckgo-slide-container': true } }, h("div", { class: "deckgo-slide" }, h("slot", { name: "title" }), h("div", { class: "deckgo-big-img-container" }, h("img", { "data-src": this.imgSrc, alt: this.imgAlt }), h("slot", { name: "notes" }), h("slot", { name: "actions" }), h("slot", { name: "background" })))));
    };
    Object.defineProperty(class_1.prototype, "el", {
        get: function () { return getElement(this); },
        enumerable: true,
        configurable: true
    });
    return class_1;
}());
DeckdeckgoSlideBigImg.style = deckdeckgoSlideBigImgCss;
export { DeckdeckgoSlideBigImg as deckgo_slide_big_img };
